package yt_java_kaufhaus_playlist;

import java.util.Comparator;
import java.util.HashSet;
import java.util.OptionalDouble;
import java.util.Set;
import java.util.TreeSet;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Progtramm {

	public static void main(String[] args) {
		// TODO Auto-generated method stub

		
		//Prfe, ob Waren inhaltlich identisch anhand von HashCode und Equals 
		HashSet<Ware> haus1 = new HashSet<>();
		haus1.add(new Ware("Hemd", 23.45));
		haus1.add(new Ware("Socken", 5.99));
		haus1.add(new Ware("Grill", 99.99));
		haus1.add(new Ware("Gartenstuhl", 49.99));
		haus1.add(new Ware("Badetuch", 12.99));
		haus1.add(new Ware("Kochtopf", 19.89));
		haus1.add(new Ware("Roller", 99.99));   //Roller ist hnlich zu Socken, weil gleiche Anzahl Buchstaben 
		haus1.add(new Ware("Roller", 99.99));		//nicht hinzufgen
		
		System.out.println("Anzahl: " + haus1.size());
		
		//Ausgabe aller Waren 
		haus1.forEach(w -> System.out.println(w));
		
		System.out.println("---------------------");
		
		//nur die Bezeichnung 
		haus1.stream().map(w -> w.bezeichnung).forEach(System.out::println);
		
		System.out.println("---------------------");
		
		//Feuerzeug, wenn vorhanden 
		haus1.stream().filter(w -> w.bezeichnung.equals("Feuerzeug")).findFirst()
		.ifPresentOrElse(System.out::println, () -> System.out.println("Kein Feuerzeug :( "));
		
		System.out.println("---------------------");
		
		//Preis zwischen 20 und 60 
		haus1.stream().filter(w -> w.preis > 20 && w.preis < 60).forEach(System.out::println);
		
		System.out.println("---------------------");
		
		//Durchschnitt 
		haus1.stream().mapToDouble(w -> w.preis).average()
		.ifPresentOrElse(System.out::println, () -> System.out.println("kein Durchschnitt"));
		
		System.out.println("---------------------");
		
		
		//Aufsteigende Sortierung 
		//haus1.stream().sorted().forEach(System.out::println);		 -- setzt voraus Comparable bei Ware
		haus1.stream().sorted(Comparator.comparingDouble(w -> w.preis)).forEach(System.out::println);
		
		System.out.println("---------------------");
		
		//maxi Preis 
		double maxi = haus1.stream().mapToDouble(w -> w.preis).max().getAsDouble();
		haus1.stream().filter(w -> w.preis.equals(maxi)).forEach(System.out::println);

		
		
		System.out.println("---------------------");
		// gnstige 3 
		
		haus1.stream().sorted(Comparator.comparingDouble(w->w.preis)).limit(3).forEach(System.out::println);
		
		
		System.out.println("---------------------");
		
		//wir ergnzen jede Ware um ihre Steuern 
		
		haus1.stream().map(w -> new Object() {String bez = w.bezeichnung; double pr = w.preis; double steuer = w.preis/119*19;})
		.forEach(obj -> System.out.println(obj.bez + "|" + obj.pr + "|" + obj.steuer));
		
		//-----------------------------------------
		System.out.println("---------------------");
		//die Objekte im Set werden sortiert - Ware muss Interface Comparable implementieren
		TreeSet<Ware> haus2 = new TreeSet<>();
		
		haus2.add(new Ware("Grill", 89.89));
		haus2.add(new Ware("Gartenstuhl", 39.89));
		haus2.add(new Ware("Strohhut", 34.56));
		haus2.add(new Ware("Kochtopf", 23.45));
		haus2.add(new Ware("Gummistiefel", 11.99));
		haus2.add(new Ware("Gummistiefel", 11.99));
		
		haus2.forEach(System.out::println);
		
		System.out.println("---------------------");
		/*
		Ware w1 = new Ware("Grill", 79.99);
		Ware w2 = new Ware("Hemd", 129.99);
		
		System.out.println(w1.bezeichnung.compareTo(w2.bezeichnung));
		*/
		
		//alle Waren in eine groe Sammlung berfhren - inkl Namen des Hauses 
	    HashSet<Artikel> alle = new HashSet<>();
	    alle.addAll(haus1.stream().map(w -> new Artikel("Haus1", w.bezeichnung, w.preis)).collect(Collectors.toSet()));
	    alle.addAll(haus2.stream().map(w -> new Artikel("Haus2", w.bezeichnung, w.preis)).collect(Collectors.toSet()));
	    
	    alle.forEach(System.out::println);
	    
	    System.out.println("---------------------");
	    //Gruppierung nach Haus 
	    //bei collect kommt eine Map heraus 
	    alle.stream().collect(Collectors.groupingBy(a -> a.haus)).forEach((h, liste) -> System.out.println(h + "|" + liste.size()));
	    
	    System.out.println("---------------------");
	    
	    //Welche Ware ist in welchem Haus am gnstigsten 
	    alle.stream().collect(Collectors.groupingBy(a -> a.bezeichnung))
	    .forEach((a,liste) -> System.out.println(a + "|" + liste.stream().min((w1,w2) -> w1.preis.compareTo(w2.preis)).toString()) );
	    
	    System.out.println("---------------------");
	    
	    //welche Ware nur im Haus 2 - ACHTUNG: hier Kombi von bezeichnung und preis einmalig 
	    haus2.stream().filter(w -> !haus1.contains(w)).forEach(System.out::println);
	
	    System.out.println("---------------------");
	    
	    Set<String> bezH2 = haus2.stream().map(w -> w.bezeichnung).collect(Collectors.toSet());
	    Set<String> bezH1 = haus1.stream().map(w -> w.bezeichnung).collect(Collectors.toSet());
	    
	    bezH2.stream().filter(w -> !bezH1.contains(w)).forEach(System.out::println);
	    
	    System.out.println("---------------------");
	    

	    
	}

}
